/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package com.travisperkins.queues;

import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.PrintStream;

public class AppTest {
    private final InputStream systemIn = System.in;
    private final PrintStream systemOut = System.out;

    @BeforeEach
    public void setUpInput() {
        // Set up input stream with sample messages
        String input = "A AT12 10 1 2023-05-18T10:00:00.000Z\n" +
                "B XY99 5 2 2023-05-18T10:00:00.000Z\n" +
                "C CC34 8 3 2023-05-18T10:00:00.000Z\n" +
                "D KK37 15 4 2023-05-18T10:00:00.000Z\n";
        System.setIn(new ByteArrayInputStream(input.getBytes()));
    }

    @AfterEach
    public void restoreSystemInputOutput() {
        // Restore original input and output streams
        System.setIn(systemIn);
        System.setOut(systemOut);
    }
    @Test
    public void testQueueApp() {
        // Capture the output
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        System.setOut(new PrintStream(outputStream));

        // Execute the QueueApp
        App.main(new String[0]);

        // Assert the expected output
        String expectedOutput = "Enter 4 instruction messages, one by one, followed by 'Enter' key\n"+
                "Checking if the queue is empty: false\n" +
                "List of messages : \n" +
                "message : D KK37 15 4 2023-05-18T10:00:00.000Z\n"+
                "message : C CC34 8 3 2023-05-18T10:00:00.000Z\n" +
                "message : B XY99 5 2 2023-05-18T10:00:00.000Z\n" +
                "message : A AT12 10 1 2023-05-18T10:00:00.000Z\n" +
                "Removing the highest-priority message : \n" +
                "A AT12 10 1 2023-05-18T10:00:00.000Z\n" +
                "List of messages : \n" +
                "message : D KK37 15 4 2023-05-18T10:00:00.000Z\n" +
                "message : C CC34 8 3 2023-05-18T10:00:00.000Z\n" +
                "message : B XY99 5 2 2023-05-18T10:00:00.000Z\n" +
                "Retrieving the new highest-priority message :\n" +
                "B XY99 5 2 2023-05-18T10:00:00.000Z\n" +
                "Number of messages currently on the queue: 3\n" +
                "List of messages : \n" +
                "message : D KK37 15 4 2023-05-18T10:00:00.000Z\n" +
                "message : C CC34 8 3 2023-05-18T10:00:00.000Z\n" +
                "message : B XY99 5 2 2023-05-18T10:00:00.000Z\n";

        Assertions.assertEquals(expectedOutput, outputStream.toString());
    }
}

